stages:
  - build
  - test

.buildTarget:
  image:
    name: registry.gitlab.com/syntgroup/extractor/poky-docker-sdk:latest
  script:
    - echo "building BEGIN"
    - mkdir build
    - cd build
    - . /opt/poky/3.1.13/environment-setup-cortexa7t2hf-neon-vfpv4-poky-linux-gnueabi
    - cmake -DBUILD_EMBEDDED=ON -DBUILD_JSON=OFF -DBUILD_SHARED_LIBS=OFF -Dextractor-core_DEVELOPER_MODE=ON -DBUILD_TESTING=OFF -DCMAKE_BUILD_TYPE=MinSizeRel -G Ninja -S ../ -B .
    - cmake --build . --target all

.buildHost:
  image:
    name: registry.gitlab.com/syntgroup/libs/extractor-core:latest

build host:
  extends: .buildHost
  stage: build
  script:
    - echo "building BEGIN"
    - cmake --preset=ci-ubuntu
    - cd build/
    - cmake --build . --target format-check
    - cmake --build . --target all
  only:
    - develop
    - merge_request

build target:
  extends: .buildTarget
  stage: build
  only:
    refs:
      - develop
      - merge_request

test coverage:
  extends: .buildHost
  stage: test
  script:
    - echo "BUILDING BEGIN"
    - echo ${CI_JOB_ID} > CI_JOB_ID.txt
    - cmake --preset=ci-coverage
    - cd build/coverage
    - cmake --build . --target all
    - echo "BUILDING DONE"
    - echo "TEST BEGIN"
    - ctest . --output-junit report.xml --rerun-failed --output-on-failure
    - echo "TEST DONE"
    - echo "COVERAGE BEGIN"
    - cmake --build . --target coverage
    - echo "COVERAGE DONE"
  only:
    refs:
      - develop
      - merge_request
  coverage: /^\s*lines:\s*\d+.\d+\%/
  artifacts:
    name: ${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}-${CI_COMMIT_SHA}
    when: always
    expire_in: 2 days
    reports:
      junit: build/coverage/report.xml
      coverage_report:
        coverage_format: cobertura
        path: build/coverage/coverage.xml
